<form
    id="speciesSiteForm"
    [formGroup]="speciesSiteForm"
    (ngSubmit)="onFormSubmit()"
>

    <div class="form-row">
        <div class="form-group col-lg-6 col-md-12 half">
            <h5>Informations</h5>
            <label for="species-site-name">*Nom de l'individu</label>
            <input
                id="species-site-name"
                type="text"
                formControlName="name"
                class="form-control"
                placeholder="ex : Noisetier1 ; Noisetier près de la maison"
            />

            <div class="form-group">
                <input
                    formControlName="id_area"
                    type="hidden"
                />
                <div class="mt-2 mb-2">
                    <label
                        for="cd_nom"
                        class="m-0"
                    >
                        {
                        autocomplete, select,
                        isOn {Rechercher une esp&egrave;ce}
                        isOff {S&eacute;lectionnez une esp&egrave;ce}
                        }
                    </label>
                    <i
                        ngbTooltip="Un doute sur une espèce ? Vous pouvez consulter les fiches espèces, ajouter une photo que nous examinerons, ou encore nous envoyer un mail à phenoclim@creamontblanc.org"
                        class="fa fa-question-circle ml-1"
                        placement="bottom"
                    ></i>
                </div>
                <!-- TAXON SELECT -->
                <div *ngIf="
                        taxaCount >= taxonSelectInputThreshold &&
                        taxaCount < taxonAutocompleteInputThreshold
                    ">
                    <select
                        formControlName="cd_nom"
                        class="form-control rounded-0"
                    >
                        <option [value]="null">
                        </option>
                        <option
                            *ngFor="let s of taxa"
                            [value]="s.taxref.cd_nom"
                        >
                            {{
                            !!s.nom_francais
                            ? s.nom_francais
                            : s.taxref.nom_vern
                            }}
                            <span *ngIf="mainConfig.taxonDisplaySciName">(<i>{{ s.taxref.nom_complet }}</i>)</span>
                        </option>
                    </select>
                </div>
            </div>
            <!-- TAXON PICKER -->
            <div
                *ngIf="taxaCount < taxonSelectInputThreshold"
                class="form-group col-lg-12 d-inline-flex obs-images"
            >
                <div
                    class="scroll-img"
                    [class.ng-valid]="selectedTaxon"
                    [class.ng-invalid]="!selectedTaxon"
                >
                    <div *ngFor="let s of taxa">
                        <div
                            class="obs-img default-img"
                            [class.selected]="isSelectedTaxon(s)"
                        >
                            <img
                                [src]="
                                s.medias && !!s.medias.length
                                    ? mainConfig.API_TAXHUB +
                                      '/tmedias/thumbnail/' +
                                      s.medias[0].id_media +
                                      '?h=100&v=100'
                                    : 'assets/default_image.png'
                            "
                                [alt]="
                                !!s.nom_francais
                                    ? s.nom_francais
                                    : s.taxref.nom_vern
                            "
                                (click)="onTaxonSelected(s)"
                            />
                            <span>
                                {{
                                !!s.nom_francais
                                ? s.nom_francais
                                : s.taxref.nom_vern
                                }}
                            </span>
                        </div>
                    </div>
                </div>
            </div>
            <!-- TAXON AUTOCOMPLETE -->
            <div
                *ngIf="taxaCount >= taxonAutocompleteInputThreshold"
                class="form-group"
            >
                <ng-template
                    #rt
                    let-r="result"
                    let-t="term"
                >
                    <img
                        [src]="r.icon"
                        class="mr-1"
                        style="height: 1em"
                    />
                    <ngb-highlight
                        [result]="r.name"
                        [term]="t"
                    ></ngb-highlight>
                </ng-template>
                <input
                    id="cd_nom"
                    type="text"
                    class="form-control rounded-0"
                    formControlName="cd_nom"
                    placeholder="Nom latin ou vernaculaire ou cd_ref"
                    [editable]="false"
                    [ngbTypeahead]="inputAutoCompleteSearch"
                    [resultTemplate]="rt"
                    [inputFormatter]="inputAutoCompleteFormatter"
                />
            </div>

            <json-schema-form
                *ngIf="formInputObject"
                [form]="formInputObject"
                [options]="formOptions"
                (onChanges)="yourOnChangesFn($event)"
                [framework]="GNCBootstrap4Framework"
                (isValid)="setJsonFormIsValid($event)"
            >
            </json-schema-form>
        </div>
        <div class="form-group col-lg-6 col-md-12 half">
            <h5>Cliquez sur la carte pour localiser votre individu</h5>
            <div class="position-relative">
                <div
                    class="zoom-alert"
                    *ngIf="hasZoomAlert"
                >
                    <div
                        class="mb-2 text-center"
                        i18n="Zooming instruction@@zoomingInstruction"
                    >
                        Veuillez zoomer pour localiser votre individu.<br />
                        <span>(zoom min:
                            {{ mainConfig.ZOOM_LEVEL_RELEVE }})</span>
                    </div>
                    <button
                        class="btn"
                        (click)="hasZoomAlert = false"
                    >
                        OK
                    </button>
                </div>
                <div
                    id="formMap"
                    class="col-lg-12"
                    [class.ng-invalid]="speciesSiteForm.get('geometry').invalid"
                    [class.ng-valid]="speciesSiteForm.get('geometry').valid"
                    data-observation-zoom-statement-warning="Veuillez zoomer pour localiser votre individu."
                ></div>
            </div>
            <input
                formControlName="geometry"
                type="hidden"
                id="geometry"
                name="geometry"
                #geometry
                class="col-lg-12"
            />

            <div
                *ngIf="data.speciesSiteUpdateData && data.speciesSiteUpdateData.photos && data.speciesSiteUpdateData.photos.length"
                class="mt-3 mb-3"
            >
                <label i18n="Existing Photos@@existingPhotos">
                    Photos existantes (cocher pour supprimer)
                </label><br />
                <div class="d-flex flex-wrap align-items-center ">
                    <div
                        *ngFor="let p of data.speciesSiteUpdateData.photos"
                        class="mx-2 my-1"
                    >
                        <input
                            type="checkbox"
                            name=""
                            [(ngModel)]="p.checked"
                            [ngModelOptions]="{ standalone: true }"
                            class="mr-1"
                        />
                        <img
                            src="{{ mainConfig.API_ENDPOINT }}{{ p.url }}"
                            height="50"
                        />
                    </div>
                </div>
            </div>

            <image-upload
                buttonCaption="Ajouter une photo"
                dropBoxMessage="Déposez vos photos ici !"
                clearButtonCaption="Supprimer"
                (uploadFinished)="addImage($event)"
                (removed)="deleteImage($event)"
            >
            </image-upload>
        </div>
    </div>
    <!-- <div class="alert alert-primary rounded-0" role="alert">
      <pre>{{ speciesSiteForm.value | json }}</pre>
    </div> -->
</form>
